Bug 1553803 - RFE: CGROUP File system does not work correctly with SELinux labels
Summary: RFE: CGROUP File system does not work correctly with SELinux labels
Status: CLOSED UPSTREAM
Alias: None
Product: Fedora
Classification: Fedora
Component: kernel
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Ondrej Mosnacek
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Keywords:
Depends On:
Blocks: 1558179 1510139 1558178
TreeView+ depends on / blocked
 
Reported: 2018-03-09 15:04 UTC by Daniel Walsh
Modified: 2019-03-21 09:04 UTC (History)
26 users (show)

(edit)
Clone Of:
: 1558178 1558179 (view as bug list)
(edit)
Last Closed: 2019-03-21 09:04:29 UTC


Attachments (Terms of Use)


External Trackers
Tracker ID Priority Status Summary Last Updated
Github SELinuxProject selinux-kernel issues 39 None None None 2018-03-11 16:54 UTC

Description Daniel Walsh 2018-03-09 15:04:19 UTC
When creating a new directory in a cgroup file system, the new directory by default should get the label of the parent directory.

If I label a directory 

/sys/fs/cgroup/unified/system.slice/docker-UUID

system_u:object_r:container_file_t:s0:c1,c2

Now I go into this directory and create a new directory.

The directory ends up labeled as

system_u:object_r:cgroup_t:s0

Where it should have been labeled

system_u:object_r:container_file_t:s0:c1,c2

This bug is preventing us for further locking down containers, by allowing them to modify partial hiarchies.

Comment 1 Stephen Smalley 2018-03-09 15:22:39 UTC
I think that supporting this requires patching kernfs (used internally by cgroup) to call security_inode_init_security() on newly created files.  See mm/shmem.c:shmem_mknod() for an example of how we do this for tmpfs.

Comment 9 Dusty Mabe 2018-04-13 14:48:29 UTC
any progress on this in fedora?

Comment 10 Paul Moore 2018-04-13 16:34:22 UTC
(In reply to Dusty Mabe from comment #9)
> any progress on this in fedora?

Nope, we don't have an upstream solution yet.  I'll update this BZ when there is something significant to share.

I spent a little bit of time on this a week (or two?) ago but I haven't been able to find any time to get back to it.

You can find my notes, as well as Stephen's comments, in the upstream GitHub tracker linked to this BZ (look up top).

Comment 11 Daniel Walsh 2018-04-28 09:25:17 UTC
We really need this to move forward.  Especially was we move towards RHEL8 and V2 cgroups.

Comment 12 Paul Moore 2018-04-28 11:51:51 UTC
Understood, it remains on the list, unfortunately I just haven't had time to work on it lately. Hopefully things will settle down a bit after Summit.

Comment 14 Ondrej Mosnacek 2019-01-09 09:58:00 UTC
Initial series of patches posted upstream:
https://lore.kernel.org/selinux/20190109091028.24485-1-omosnace@redhat.com/T/

Comment 15 Ondrej Mosnacek 2019-03-21 09:04:29 UTC
Patches that resolve this issue are now merged upstream (last 7 patches):
https://git.kernel.org/pub/scm/linux/kernel/git/pcmoore/selinux.git/log/?h=e19dfdc83b60f196e0653d683499f7bc5548128f

They should be available on some future Fedora version in kernel 5.2+.


Note You need to log in before you can comment on or make changes to this bug.